
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>JS不完全国际化&amp;本地化手册 之 理论篇_javascript技巧 / iVAN</title>

    <meta name="description" content="JS不完全国际化&amp;本地化手册 之 理论篇_javascript技巧 前言  最近加入到新项目组负责前端技术预研和选型,其中涉及到一个熟悉又陌生的需求--国际化&amp;本地化.熟悉的是之前的项目也玩过,陌生的是之前的实现仅仅停留在&quot;有&quot;的阶段而已.趁着这个机会好好学习整理一下,为后面的技术选型做准备.  本篇将阐述国际化和本地化的概念,以及其中一个很重要的概念--Language tag(也叫Language code 或 Culture). 何为国际化?  国际化我认为就是应用支持多语言和文化习俗(数字.货币.日期和字符比较算法等),而本地 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">JS不完全国际化&amp;本地化手册 之 理论篇_javascript技巧</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h2>前言</h2>
<p> 最近加入到新项目组负责前端技术预研和选型，其中涉及到一个熟悉又陌生的需求——国际化＆本地化。熟悉的是之前的项目也玩过，陌生的是之前的实现仅仅停留在"有"的阶段而已。趁着这个机会好好学习整理一下，为后面的技术选型做准备。<br />
 本篇将阐述国际化和本地化的概念，以及其中一个很重要的概念——Language tag(也叫Language code 或 Culture)。</p>
<h2>何为国际化？</h2>
<p> 国际化我认为就是应用支持多语言和文化习俗(数字、货币、日期和字符比较算法等)，而本地化则是应用能识别用户所属文化习俗自动适配至相应的语言文化版本。<br />
 过去常常以为国际化就是字符串的替换——如"你好!"替换为"What's up, man!"，其实具体是分为以下5方面:</p>
<ol>
<li>字符串替换<br />
   如<code>"你好!"</code>替换为<code>"What's up, man!"</code>.</li>
<li>数字表示方式<br />
   如<code>1200.01</code>，英语表示方式为<code>1,200.01</code>，而法语则为<code>1 200,01</code>，德语则为<code>1.200,01</code>.</li>
<li>货币表示方式<br />
   如人民币<code>￥1,200.01</code>，美元表示方式为<code>$1,200.01</code>，而英语的欧元则为<code>?1,200.01</code>，德语的欧元则为<code>1.200,01 ?</code>.<br />
  注意: 这里没有还没算上汇率呢.</li>
<li>日期表示方式<br />
   如<code>2016年9月15日</code>，英语表示方式为<code>9/15/2016</code>, 而法语为<code>15/9/2016</code>, 德语为<code>15.9.2016</code>.</li>
<li>字符比较算法<br />
   如<code>ä</code>和<code>z</code>比较时，英语、德语中均是<code>ä</code>排在<code>z</code>前面，而在瑞典语中则是<code>z</code>排在<code>ä</code>前面.</p>
<h2>本地化的关键 —— Language Tag</h2>
<p> 既然要自动适配至用户所属的语言文化版本，那么总得有个根据才能识别吧？我想大家应该对<code>zh-CN</code>和<code>en</code>等不陌生吧，而它们正是我们所需的根据了！在我们使用已有i18n库实现国际化/本地化时，必定会写下以下文档</p>
<pre>
{
 "en": { "name": "Enter Name" },
 "zh-CN": { "name": "输入姓名" }
}</pre>
<p> 但除了<code>en</code>和<code>zh-CN</code>还有其他键吗？它们的组成规则又是如何的呢？下面我们来稍微深入的了解这些Language Tag吧！</li>
</ol>
<h3>语法规则</h3>
<p>注意以下采用ABNF语言描述(ABNF的语法请参考语法规范：BNF与ABNF)</p>
<pre>
Language-Tag = langtag
    / privateuse
    / grandfathered

langtag = language
   ["-" script]
   ["-" region]
   *("-" variant)
   *("-" extension)
   ["-" privateuse]</pre>
<p>可以看到<code>Language-Tag</code>分为<code>langtag</code>，<code>privateuse</code> 和 <code>grandfatherd</code>三个子类,下面我们先了解一般情况用不上的两个吧！<br /><strong>privateuse</strong><br />
 标签的意思不由subtag registry定义，而是由使用的团队间私自定义、维护和使用。<br />
 格式:</p>
<pre>
privateuse = "x" 1*("-" (1*8alphanum))</pre>
<p>示例:<code>x-zh-CN</code>是privateuse，其意思不一定与language<code>zh-CN</code>一致。<br />
注意: 只作为小集团内部用可以，决不能大范围适用。</p>
<p><strong>grandfathered</strong><br />
 用于向后兼容。由于RFC 4646前的标签无法完全匹配当前registry的标签语法和意思，因此通过grandfathered来提供向后兼容的特性。<br />
 语法:</p>
<pre>
grandfathered = irregular
    / regualr
irregular = "en-GB-oed"   ; irregular tags do not match
   / "i-ami"    ; the 'langtag' production and
   / "i-bnn"    ; would not otherwise be
   / "i-default"   ; considered 'well-formed'
   / "i-enochian"  ; These tags are all valid,
   / "i-hak"    ; but most are deprecated
   / "i-klingon"   ; in favor of more modern
   / "i-lux"    ; subtags or subtag
   / "i-mingo"
   / "i-navajo"
   / "i-pwn"
   / "i-tao"
   / "i-tay"
   / "i-tsu"
   / "sgn-BE-FR"
   / "sgn-BE-NL"
   / "sgn-CH-DE"
regular = "art-lojban"  ; these tags match the 'langtag'
  / "cel-gaulish"  ; production, but their subtags
  / "no-bok"   ; are not extended language
  / "no-nyn"   ; or variant subtags: their meaning
  / "zh-guoyu"   ; is defined by their registration
  / "zh-hakka"   ; and all of these are deprecated
  / "zh-min"   ; in favor of a more modern
  / "zh-min-nan"  ; subtag or sequence of subtags
  / "zh-xiang"</pre>
<p>注意: 几乎所有grandfarthered标签均可被当前registry的标签及其组合作替代(像<code>i-tao</code>可以被<code>tao</code>代替)，因此如无意外请使用现行的标签吧。</p>
<p>下面就到了我们的重头戏langtag了,首先我们看看langtag下的第一个subtag——language.</p>
<h4>Primary language subtag</h4>
<p> 像<code>en</code>这种就是Primary language subtag，用于标识资源所对应的语言。<br />
 语法:</p>
<pre>
language = 2*3ALPAH
   ["-" extlang]
   / 4ALPHA
   / 5*8ALPHA
extlang = 3ALPHA
   *2("-" 3ALPHA)</pre>
<p>看到language有三种形式，其中让我比较好奇的是第一种<code>2*3ALPHA ["-" extlang]</code>。这种形式中前面的<code>2*3ALPHA</code>称为macrolanguage，用于标明资源对应一种语言的汇总，而具体的某一种语言/方言则通过extlang指定。而包含extlang部分的language也被称为encompassed language.<br />
如<code>zh-cmn</code>和<code>zh-yue</code>就是encompassed language，其中<code>zh</code>是macrolanguage，而<code>cmn</code>和<code>yue</code>则是extlang。<br />
 这里有个很有趣的事情是，我们认为普通话和广东话等都是汉语的方言，但西方却认为普通话、广东话根本就不属于一种语言，因此像<code>zh-cmn</code>和<code>zh-yue</code>在规范中被设置为redundant，建议直接使用<code>cmn</code>和<code>yue</code>等。不过由于历史原因，我们还是使用<code>zh-CN</code>代表<code>cmn-CN</code>。<br />
 另外现在可以作为macrolanguage的就只有7个标签(<code>ar</code>,<code>kok</code>,<code>ms</code>,<code>sw</code>,<code>uz</code>,<code>zh</code>和<code>sgn</code>)<br />
 另外几个和cmn类似的subtags如下</p>
<pre>
cmn 普通话（官话、国语）
wuu 吴语（江浙话、上海话）
czh 徽语（徽州话、严州话、吴语-徽严片）
hak 客家语
yue 粤语（广东话）
nan 闽南语（福建话、台语）
cpx 莆仙话（莆田话、兴化语）
cdo 闽东语
mnp 闽北语
zco 闽中语
gan 赣语（江西话）
hsn 湘语（湖南话）
cjy 晋语（山西话、陕北话）</pre>
<p>注意: 一般采用全小写</p>
<h4>Script subtag</h4>
<p> 用于指定字迹或文字系统资源所属的语言和方言等。<br />
 语法:</p>
<pre>
script = 4ALPHA</pre>
<p>注意: 一般采用首字母大写，后续字母全小写</p>
<h4>Region subtag</h4>
<p> 指定与国家、地域对应的语言/方言文化。<br />
 语法:</p>
<pre>
region = 2ALPHA
  / 3DIGIT</pre>
<p>注意: 一般采用全大写</p>
<h4>Variant subtag</h4>
<p> 指定其他subtag又无法提供的额外信息<br />
 语法:</p>
<pre>
variant = 5*8alphanum
  / (DIGIT 3alphanum)</pre>
<p>示例:<code>de-CH-1996</code>其中1996是variant subtag，整体意思是在Switzerland使用的自1996改良过的德语。</p>
<h4>Extension subtag</h4>
<p> 提供一种机制让我们去扩展langtag<br />
 语法:</p>
<pre>
extension = singleton 1*("-" (2*8alphanum))
singleton = DIGIT
   / %x41-57
   / %x59-5A
   / %x61-77
   / %x79-7A</pre>
<p>现在仅支持<code>u</code>作为sigleton的值。<br />
示例:<code>de-DE-u-co-phonebk</code>表示采用电话本核对的方式对内容进行排序等操作。</p>
<p>更多关于language-tag的信息请参考BCP 47</p>
<h3>如何选择Language Tag</h3>
<p> 硬着头皮啃下这么多规范的内容，但我还不知道如何组合合适的language-tag呢:(其实选择和组合的原则就只有一条<br /><strong>在足以区别当前上下文中其他language-tag的前提下，保持language-tag足够地短小精干</strong><br />
示例1:下文普通话、粤语并存</p>
<pre>
&lt;p lang="cmn"&gt;
小陈说:"老大爷，东方广场怎么走啊？"
老大爷回答道:"&lt;span lang="yue"&gt;你讲咩也啊？我听唔明喔。&lt;/span&gt;"
&lt;/p&gt;</pre>
<p>示例2:下文含大陆人讲英语、香港人讲普通话和美国人说英语</p>
<pre>
&lt;p lang="cmn"&gt;
小陈说:"&lt;span lang="en-CN"&gt;Hi, where are you come from?&lt;/span&gt;"
李先生说:"&lt;span lang="cmn-HK"&gt;你的英文跟我的普通话一样普通啊，哈哈！&lt;/span&gt;"
Simon说:"&lt;span lang="en"&gt;Hey, what's up!&lt;/span&gt;"
&lt;/p&gt;</pre>
<p> 那现在引出另一个问题，那就是我们怎么知道各个subtag具体定义了哪些值呢？<br />
具体都定义在IANA Language Subtag Registry中了。<br />
假如觉得查找起来还是不方便，那么就使用Language Subtag Lookup tool吧！<br />
另外若不清楚各国各地区所使用的语言或方言时，可通过Ethnologue查看，直接点击地图上的区域即可获取相应的subtag信息。</p>
<h2>总结</h2>
<p> 现在我们已经对国际化和本地化有了更全面的理解，也对Language tag有了更深入的认识，现在是不是迫不及待想挽起袖子撸代码呢？敬请期待下篇《JS魔法堂:不完全国际化&amp;本地化手册 之 实战篇》</p>
<h2>感谢</h2>
<p>网页头部的声明应该是用 lang="zh" 还是 lang="zh-cn"？<br />
Language Subtag Registry<br />
BCP 47<br />
Language on the Web<br />
Choosing a Language Tag<br />
Language tags in HTML and XML</p>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索国际化<br />
                                    本地化手册<br />
                                    js 国际化、angularjs 国际化、js国际化 i18n、js 国际化 语言切换、js 国际化 方案，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-01 08:11:49</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%9c%ac%e5%9c%b0%e5%8c%96%e6%89%8b%e5%86%8c/" title="本地化手册">本地化手册</a>, <a href="https://www.iamivan.net/tag/%e5%9b%bd%e9%99%85%e5%8c%96/" title="国际化">国际化</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>JS不完全国际化&amp;本地化手册 之 理论篇_javascript技巧的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgVvw3b.html" rel="bookmark">JS魔法堂：不完全国际化&amp;amp&semi;本地化手册之理论篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 最近加入到新项目组负责前端技术预研和选型,其中涉及到一个熟悉又陌生的需求--国际化&amp;本地化.熟悉的是之前的项目也玩过,陌生的是之前的实现仅仅停留在&quot;有&quot;的阶段而已.趁着这个机会好好学习整理一下,为后面的技术选型做准备. 本篇将阐述国际化和本地化的概念,以及其中一个很重要的概念--Language tag(也叫Language code 或 Culture). 何为国际化? 国际化我认为就是应用支持多语言和文化习俗(数字.货币.日期和字符比较算法等),而本地化则是应用能识别			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZEy35p.html" rel="bookmark">JS魔法堂&colon;不完全国际化&amp;amp&semi;本地化手册 之 实战篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言  最近加入到新项目组负责前端技术预研和选型,其中涉及到一个熟悉又陌生的需求--国际化&amp;本地化.熟悉的是之前的项目也玩过,陌生的是之前的实现仅仅停留在&quot;有&quot;的阶段而已.趁着这个机会好好学习整理一下,为后面的技术选型做准备.  本篇将于大家一起挽起袖子撸代码:) 如何获取Language tag?  在实现本地化处理前,我们起码先要获取Language tag吧?那么获取方式分为两类 1.直接获取浏览器的Language tag信息  一般来说浏览器语言的版本标示着用户所属或			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bE6wB9M.html" rel="bookmark">JS魔法堂&colon;不完全国际化&amp;amp&semi;本地化手册 之 拓展篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言  最近加入到新项目组负责前端技术预研和选型,其中涉及到一个熟悉又陌生的需求--国际化&amp;本地化.熟悉的是之前的项目也玩过,陌生的是之前的实现仅仅停留在&quot;有&quot;的阶段而已.趁着这个机会好好学习整理一下,为后面的技术选型做准备.  本篇作为系列的最后一篇,打算和大家一起看看HTTP的Content Negotiation机制和更多关于本地化的应用方向. Content Negotiation(内容协同)  记得第一次接触国际化和本地化时是指服务端根据请求头字段Accept-Lan			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYN7kep.html" rel="bookmark">JS中BOM相关知识点总结&lpar;必看篇&rpar;&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				window对象 ECMAScript是JavaScript的核心,但是如果要在web中使用javascript,那么BOM(浏览器对象模型)才是真正的核心.BOM提供了很多对象,用于访问浏览器的功能,这些功能与任何网页内容无关. window对象:BOM的核心对象是window,它表示浏览器的一个实例.在浏览器中,window对象有双重角色,它既是通过javascript访问浏览器窗口的一个接口,又是ECMAScript规定的Global对象. 因此,所有全局作用域中声明的变量.函数都会变成w			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8NA5xb.html" rel="bookmark">浅析JS中对函数function的理解&lpar;基础篇&rpar;&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				正文:我们知道,在js中,函数实际上是一个对象,每个函数都是Function类型的实例,并且都与其他引用类型一样具有属性和方法.因此,函数名实际上是指向函数对象的指针,不与某个函数绑定.在常见的两种定义方式(见下文)之外,还有一种定义的方式能更直观的体现出这个概念: var sum = new Function(&quot;num1&quot;, &quot;num2&quot;, &quot;return num1 + num2&quot;); //不推荐 Function的构造函数可以接收任意数量的参			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDkjD0p.html" rel="bookmark">js调试系列 断点与动态调试&lbrack;基础篇&rsqb;&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上几篇文章已经为大家介绍了js调试系列的一些基础知识,这次乱码兄弟为大家带来了js断点与动态调试方法,需要的朋友可以参考下 昨天留的课后练习 1. 分析 votePost 函数是如何实现 推荐 的. 其实我们已经看到了源码,只要读下源码即可知道他是怎么实现的了. function votePost(n, t, i) { i || (i = !1); var r = { blogApp: currentBlogApp, postId: n, voteType: t, isAbandoned: i			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7ZnQ4p.html" rel="bookmark">JS魔法堂&colon;不完全国际化&amp;amp&semi;本地化手册 之 理論篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言  最近加入到新项目组负责前端技术预研和选型,其中涉及到一个熟悉又陌生的需求--国际化&amp;本地化.熟悉的是之前的项目也玩过,陌生的是之前的实现仅仅停留在&quot;有&quot;的阶段而已.趁着这个机会好好学习整理一下,为后面的技术选型做准备.  本篇将阐述国际化和本地化的概念,以及其中一个很重要的概念--Language tag(也叫Language code 或 Culture). 何为国际化?  国际化我认为就是应用支持多语言和文化习俗(数字.货币.日期和字符比较算法等),而本地化则是应用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0NDN8z.html" rel="bookmark">推荐阅读的js快速判断IE浏览器&lpar;兼容IE10与IE11&rpar;&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				判断是否IE浏览器用的是window.navigator.userAgent,跟踪这个信息,发现在开发环境,识别为IE10,但访问服务器则识别为IE11,但IE11的userAgent里是没有MSIE标志的,原因就是这个了. 把判断IE浏览器的方法改成如下就可以了. function isIE() { //ie? if (!!window.ActiveXObject || &quot;ActiveXObject&quot; in window) return true; else return false			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0NX80z.html" rel="bookmark">JS随机洗牌算法之数组随机排序&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				推荐阅读:JavaScript学习笔记之数组的增.删.改.查 JavaScript学习笔记之数组求和方法 JavaScript学习笔记之数组随机排序 洗牌算法是一个比较形象的术语,本质上让一个数组内的元素随机排列.举例来说,我们有一个如下图所示的数组,数组长度为 9,数组内元素的值顺次分别是 1~9: 从上面这个数组入手,我们要做的就是打乱数组内元素的顺序: 代码实现 维基百科上的 Fisher–Yates shuffle 词条对洗牌算法做了详细介绍,下面演示的算法也是基于其中的理论编写的: A			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbEmZ6b.html" rel="bookmark" class="title">ifttt刚火&comma;到底要不要抄？什么时候抄？</a>
					<div>
						文章描述:在新兴市场,抄可以快速起步,且与被抄对象比有独特优势的时候,要抄. ifttt刚火,赝品就出现了.但似乎一夜之间,舆论都在大谈和标榜各种自主创新,知识产权.&quot;抄袭&quot;成了过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAa2E3M.html" rel="bookmark" class="title">Visual Studio 2008&plus;NClay小试牛刀</a>
					<div>
						经过一段时间的努力,NClay框架终于到了可以见人的阶段了,为了让大家了解NClay,于是基于NClay编写了一个SmallBlog程序作为介绍案例.在开发SmallBlog过程中,刚好VS 2008 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj7GQNM.html" rel="bookmark" class="title">使用Java Applet访问数据库</a>
					<div>
						学习任何的程序语言,当然都得与数据库,Java刚刚诞生的时候,对数据库的支持并不是很好,经过这几年的发展,它对数据库的支持也已经完全达到了成熟的境地.由于这里主要是介绍Java Applet小程序,  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAaG9ZM.html" rel="bookmark" class="title">在&period;NET中使用MySql数据库</a>
					<div>
						在.NET中使用Sql Server是一直的事情.前几天学习通过JDBC使用Java连接MySql数据库,我就想.NET是否同样可以使用MySql数据库呢?答案是肯定的,方法也很简单,在这里我使用C# ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNELx7b.html" rel="bookmark" class="title">Ubuntu系统中使用火狐OS模拟器体验Firefox OS</a>
					<div>
						西班牙已经发布了基于Firefox OS的手机,但是不是任何人能体验到,很都人都在苦苦等待,现在我们有另一种方法,不需要任何命令,没有纷繁复杂的安装步骤,在该文中,会教大家在ubuntu系统中一种轻松 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLy43b.html" rel="bookmark" class="title">Effective C&num;原则21：用委托来表示回调</a>
					<div>
						我:&quot;儿子,到院子里除草去,我要看会书.&quot; 斯科特: &quot;爸,我已经打扫过院子了.&quot; 斯科特:&quot;爸,我已经 把草放在除草机上了.&quot; 斯科特:& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62d6YM.html" rel="bookmark" class="title">知道这20个正则表达式你能少写1000行代码</a>
					<div>
						  正则表达式,一个十分古老而又强大的文本处理工具,仅仅用一段非常简短的表达式语句,便能够快速实现一个非常复杂的业务逻辑.熟练地掌握正则表达式的话,能够使你的开发效率得到极大的提升.下面是@技匠 整理 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxjvKb.html" rel="bookmark" class="title">ps绘制人物眼睛基础教程</a>
					<div>
						  最终效果   1.我们先来分析下眼睛的结构,先看下眼睛路径画法 2.加深减淡工具,擦出高光以及阴暗区域,这些过程没有任何技巧可言,都是反复的擦来擦去,得到满意的效果,最终效果如下 3.剩下的就是瞳 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Wna7b.html" rel="bookmark" class="title">ceiling语法及例子</a>
					<div>
						  ceiling函数功能:将参数 Number 向上舍入(沿绝对值增大的方向)为最接近的 significance 的倍数.例如,如果您不愿意使用像&quot;分&quot;这样的零钱,而所要购买的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnYmLAM.html" rel="bookmark" class="title">win8&period;1提示缺少xinput1</a>
					<div>
						  Win8.1系统缺少xinput1_3.dll游戏不能运行怎么办: 1.下载xinput1_3.dll文件 2.下载后解压出来,把xinput1_3.dll文件复制到系统盘SYSTEM32文件夹下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0WXy0b.html" rel="bookmark" class="title">设置U盘启动的另一方法</a>
					<div>
						  有些朋友的电脑主板在开机的时候按ESC的启动菜单里没有USB有关的启动项,在BIOS里也没有和USB启动有关的选项,那还有没有其他办法来启动电脑呢? 由于主板在启动菜单里hard disk 里有测 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myw9aPz.html" rel="bookmark" class="title">win7 64位系统下利用任务栏增强工具Bins快速释放任务栏空间</a>
					<div>
						  1.首先到网上下载并安装Bins,完成后会自动运行,然后点击&quot;下一步Next&quot;就能看到如何使用它的动画演示; 2.只要Ghost win7系统用户看过软件自带操作演示,就会发现 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ZeXob.html" rel="bookmark" class="title">酷狗音乐盒2015怎么分享到微信朋友圈</a>
					<div>
						  首先打开我们手机上的酷狗音乐.点击左上方的图标,弹出菜单中,选择本地音乐.如图 进入到本地音乐中,就可以看到你手机上面的所有音乐了,然后找到你想要分享的音乐,比如下图,我就选择了一首&quot;独 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEWaQop.html" rel="bookmark" class="title">十款绝bi好用的硬盘数据恢复软件值得拥有简易恢复</a>
					<div>
						不小心误删或是弄丢了重要文件信息怎么办?不用找代价高昂的专业数据恢复商,因为绝大多数的数据恢复软件都可以帮助你恢复被删除的文件.市面上,有很多免费数据恢复软件可帮助用户&quot;取消删除&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjmPVmz.html" rel="bookmark" class="title">&lbrack;原&rsqb;【实例化需求】1&period;FitNesse工具应用简介</a>
					<div>
						[SBE]FitNesse工具应用简介  摘要:随着敏捷精益的流行,ATDD与SBE的概念也逐渐被推广,而据&lt;实例化需求&gt;一书作者介绍,在SBE中有两款工具应用比较流行,一个是 Conco ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmGWLqb.html" rel="bookmark" class="title">JS正则中的match与exec使用说明&lowbar;正则表达式</a>
					<div>
						主要参考W3C教程 String.match()&lt;?XML:NAMESPACE PREFIX = O /&gt; match() 方法将检索目标字符串,以找到一个或多个与 正则表达式regexp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b32raAz.html" rel="bookmark" class="title">读取一个文件以二进制形式打开（读取任意二进制文件），用JFreeChart来画出曲线图</a>
					<div>
						问题描述 rt,LZ实在能力太简单,完成不了,求大神帮忙解决.具体要求如下:1.可以打开任意一个二进制文件,然后以曲线形式显示在自己构建的Chart窗口中2.可以显示多个通道,比如1通道用于显示原始数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQr9gKM.html" rel="bookmark" class="title">html5-手机按住松开的事件。</a>
					<div>
						问题描述 手机按住松开的事件. 怎么实现手机按住一个div,改变div的背景颜色,松开背景颜色又还原? 解决方案 android 按住和松开的事件imagebutton 按住和松开事件 解决方案二:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvr626M.html" rel="bookmark" class="title">ajax级联下拉框</a>
					<div>
						问题描述 学校已经是动态读取了,根据学校读取年级,根据年级读取到班级!是从数据库里读的!ajax访问即可!求大神指点一二! 解决方案 解决方案二:在学校的onchange事件中,发送ajax请求啊.解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkwRLyp.html" rel="bookmark" class="title">owl-s api中的例子有错</a>
					<div>
						问题描述 owl-s api中的例子有错 例子中的owl文件访问不到(http://www.mindswap.org/2004/owl-s/1.1/BookFinder.owl),请问在哪里可以下载这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwxZQmb.html" rel="bookmark" class="title">android-Android一个界面的实现（可能是Dialog）</a>
					<div>
						问题描述 Android一个界面的实现(可能是Dialog) 这是一个Android文件管理器对某个文件复制以后的界面,想问底下的粘贴.取消按钮是怎么做的,如果是Dialog,怎么让window内外都 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MydwYJb.html" rel="bookmark" class="title">MFC CListCtrl 使用介绍</a>
					<div>
						  以下未经说明,listctrl默认view 风格为report 相关类及处理函数 MFC:CListCtrl类 SDK:以 &quot;ListView_&quot;开头的一些宏.如 ListVi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY5576M.html" rel="bookmark" class="title">干货！小技巧帮你完成创意十足的网页设计</a>
					<div>
						干货!小技巧帮你完成创意十足的网页设计 时间:2014-10-09 14:42 来源:优设网 作者:小峰向前跑 小白叨一叨:依靠独特的设计手法,搭配上创意优秀的图片,可以让网页突破空间界限,给人留下深 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRDDkp.html" rel="bookmark" class="title">用Google API 提取名片信息</a>
					<div>
						介绍 我们每个人或多或少都会使用到名片.但是如果名片数量一大,管理它们就显得非常麻烦.因此我产生用这篇文章的案例来管理他们. 这里,我先用手机对每张名片拍照,并按以下流程进行处理: 把获得的名片图像交 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRDnNkz.html" rel="bookmark" class="title">日本海淘以及日本亚马逊海淘转运教程</a>
					<div>
						摘要: [导语]海淘已经不算新鲜事物了,但大部分网友应该没有尝试过从日本海淘.相比于从美国海淘,从日本海淘(如日本 亚马逊 )的优势在于物流时间更短,转运公司为日本股份制公 [导语]海淘已经不算新鲜事 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mydqr8b.html" rel="bookmark" class="title">SpringBoot开发案例之整合日志管理</a>
					<div>
						有一种力量无人能抵挡,它永不言败生来倔强.有一种理想照亮了迷茫,在那写满荣耀的地方. 概述 参考文档:Logging 这里顺便引用以下部分原文,当然看不明白也没关系,我们有有道翻译,如果翻译的不准确, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Rwy0z.html" rel="bookmark" class="title">dtsi-想在MT7620a上扩展uart口，发现正常使能了uart口，但是还是不能正常使用</a>
					<div>
						问题描述 想在MT7620a上扩展uart口,发现正常使能了uart口,但是还是不能正常使用 最近新买的MT7620a开发板,看芯片的资料,发现有uartlite和uart两个串口,默认的boot口是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkA7Job.html" rel="bookmark" class="title">全球最隐秘的十种恶意攻击</a>
					<div>
						说到恶意软件,我们简直生活在一个可怕的时代.每天都在听说黑客又突破了满载客户隐私数据的网络.公众对此甚至都麻木了,面对数百万记录被盗,或者公司私密邮件泄露这种事,早已是屡见不鲜.     作为安全从业 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK5ovZp.html" rel="bookmark" class="title">如何提高WordPress安全性</a>
					<div>
						安全是永恒的话题,在互联网上更是如此,本文将为大家介绍10个小诀窍来提高WordPress博客的安全性. 1.删除错误提示. 当我们登录WordPress后台失败时会显示错误信息.如果有人想攻击你的博 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgE4x8z.html" rel="bookmark" class="title">环球企业家：马云的智力游戏</a>
					<div>
						作者:王思远 靳志辉 事实上,人们反而更加认真地检视其诚信价值观,以及B2B业务增长乏力.人事争斗等问题.而回顾马云过去的几场著名&quot;公关秀&quot;,效果其实也是喜忧参半 . 策略:界定发 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
